/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         scgrammerparse
#define yylex           scgrammerlex
#define yyerror         scgrammererror
#define yydebug         scgrammerdebug
#define yynerrs         scgrammernerrs

#define yylval          scgrammerlval
#define yychar          scgrammerchar

/* Copy the first part of user declarations.  */
#line 1 "scgrammer.y" /* yacc.c:339  */

/******************************************************************************
 * DESCRIPTION: SystemC bison parser
 *
 * This file is part of SystemC-Perl.
 *
 * Author: Wilson Snyder <wsnyder@wsnyder.org>
 *
 * Code available from: http://www.veripool.org/systemperl
 *
 ******************************************************************************
 *
 * Copyright 2001-2014 by Wilson Snyder.  This program is free software;
 * you can redistribute it and/or modify it under the terms of either the GNU
 * Lesser General Public License Version 3 or the Perl Artistic License Version 2.0.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 *****************************************************************************/

#include "scparse.h"
#include "scgrammer.h"
#define YYERROR_VERBOSE
#define SCFree(p) {if (p) free(p); p=NULL;}

extern /*const*/ char *sclextext;
int scgrammerdebug = 0;
extern int sclexleng;

/* Join two strings, return result */
char *scstrjoin2ss (char *a, char *b) {
    int len = strlen(a)+strlen(b);
    char *cp=malloc(len+5);
    strcpy (cp,a); strcat(cp,b);
    SCFree (a); SCFree (b);
    return (cp);
}

/* Join two strings, return result */
char *scstrjoin2si (char *a, const char *b) {
    int len = strlen(a)+strlen(b);
    char *cp=malloc(len+5);
    strcpy (cp,a); strcat(cp,b);
    SCFree (a); /*SCFree (b);*/
    return (cp);
}

/* Join two strings, return result */
char *scstrjoin2is (const char *a, char *b) {
    int len = strlen(a)+strlen(b);
    char *cp=malloc(len+5);
    strcpy (cp,a); strcat(cp,b);
    /*SCFree (a);*/ SCFree (b);
    return (cp);
}

/* Join three strings, middle one constant, return result */
char *scstrjoin3iii (const char *a, const char *b, const char *c) {
    int len = strlen(a)+strlen(b)+strlen(c);
    char *cp=malloc(len+5);
    strcpy (cp,a); strcat(cp,b); strcat(cp,c);
    /*SCFree (a);*/ /*SCFree (b);*/ /*SCFree (c);*/
    return (cp);
}

/* Join three strings, middle one constant, return result */
char *scstrjoin3sis (char *a, const char *b, char *c) {
    char *cp=scstrjoin3iii(a,b,c);
    SCFree (a); /*SCFree (b);*/ SCFree (c);
    return (cp);
}

char *scstrjoin4iiii (const char *a, const char *b, const char *c, const char *d) {
    int len = strlen(a)+strlen(b)+strlen(c)+strlen(d);
    char *cp=malloc(len+5);
    strcpy (cp,a); strcat(cp,b); strcat(cp,c); strcat(cp,d);
    /*SCFree (a);*/ /*SCFree (b);*/ /*SCFree (c);*/ /*SCFree (d);*/
    return (cp);
}

char *scstrjoin4sisi (char *a, const char *b, char *c, const char* d) {
    char *cp=scstrjoin4iiii(a,b,c,d);
    SCFree (a); /*SCFree (b);*/ SCFree (c); /*ScFree(d);*/
    return (cp);
}

/* Emit all text including this parsed token */

int scgrammerlex() {
    int toke;
    sclex_include_switch ();
    toke = sclexlex();
    if (toke != SP && toke != AUTO) {	// Strip #sp.... from text sections, AUTOs do it separately
	scparser_PrefixCat(sclextext,sclexleng);
    }
#ifdef FLEX_DEBUG
    if (sclex_flex_debug) {
	fprintf(stderr,"ln%d: GOT %d: '%s'\n", scParserLex.lineno, toke,
		DENULL(sclextext));
    }
#endif
    return (toke);
};


#line 183 "scgrammer.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "scgrammer.h".  */
#ifndef YY_SCGRAMMER_SCGRAMMER_H_INCLUDED
# define YY_SCGRAMMER_SCGRAMMER_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif
#if YYDEBUG
extern int scgrammerdebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    STRING = 258,
    SYMBOL = 259,
    NUMBER = 260,
    PP = 261,
    SP = 262,
    COLONCOLON = 263,
    CLASS = 264,
    CONST = 265,
    ENUM = 266,
    PRIVATE = 267,
    PROTECTED = 268,
    PUBLIC = 269,
    VIRTUAL = 270,
    AUTO = 271,
    NCSC_MODULE = 272,
    SC_MODULE = 273,
    SC_SIGNAL = 274,
    SC_INOUT_CLK = 275,
    SC_CLOCK = 276,
    SC_CTOR = 277,
    SC_MAIN = 278,
    SP_CELL = 279,
    SP_CELL_DECL = 280,
    SP_MODULE_CONTINUED = 281,
    SP_PIN = 282,
    SP_TEMPLATE = 283,
    SP_TRACED = 284,
    SP_UI = 285,
    SP_COVERGROUP = 286,
    SP_COVER_SAMPLE = 287,
    COVERPOINT = 288,
    CG_PAGE = 289,
    CG_DESCRIPTION = 290,
    CG_OPTION = 291,
    CG_DEFAULT = 292,
    CG_BINS = 293,
    CG_ILLEGAL_BINS = 294,
    CG_ILLEGAL_BINS_FUNC = 295,
    CG_IGNORE_BINS = 296,
    CG_IGNORE_BINS_FUNC = 297,
    CG_LIMIT_FUNC = 298,
    CG_AUTO_ENUM_BINS = 299,
    CG_CROSS = 300,
    CG_ROWS = 301,
    CG_COLS = 302,
    CG_TABLE = 303,
    CG_WINDOW = 304,
    VL_SIG = 305,
    VL_SIGW = 306,
    VL_INOUT = 307,
    VL_INOUTW = 308,
    VL_IN = 309,
    VL_INW = 310,
    VL_OUT = 311,
    VL_OUTW = 312
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 112 "scgrammer.y" /* yacc.c:355  */

  char *string;

#line 285 "scgrammer.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE scgrammerlval;

int scgrammerparse (void);

#endif /* !YY_SCGRAMMER_SCGRAMMER_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 302 "scgrammer.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  144
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   573

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  89
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  74
/* YYNRULES -- Number of rules.  */
#define YYNRULES  239
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  533

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   312

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    73,    74,
      75,    76,    77,    78,    79,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    81,    80,    82,    83,     2,    84,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    86,    85,    87,    88,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   203,   203,   209,   209,   209,   209,   209,   209,   210,
     210,   210,   210,   210,   210,   211,   211,   211,   211,   211,
     211,   212,   212,   212,   212,   212,   212,   213,   213,   213,
     213,   213,   213,   214,   214,   217,   217,   217,   222,   223,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   272,   279,   280,   283,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   298,   299,
     302,   303,   306,   307,   308,   309,   312,   313,   316,   317,
     320,   321,   322,   323,   326,   329,   332,   335,   338,   342,
     344,   348,   349,   353,   354,   360,   361,   365,   366,   367,
     371,   380,   383,   392,   398,   404,   405,   408,   418,   419,
     422,   425,   426,   429,   430,   433,   434,   435,   438,   441,
     445,   446,   447,   448,   449,   450,   451,   454,   455,   462,
     463,   464,   468,   469,   470,   471,   472,   473,   476,   477,
     483,   484,   487,   488,   489,   490,   491,   492,   498,   501,
     502,   505,   506,   507,   510,   511,   514,   515,   518,   519,
     525,   528,   529,   535,   536,   537,   539,   542,   543,   546,
     549,   555,   561,   564,   567,   570,   573,   576,   579,   582,
     585,   593,   594,   596,   597,   599,   600,   602,   606,   607,
     609,   610,   611,   612,   614,   615,   620,   621,   624,   625,
     628,   629,   632,   638,   639,   642,   643,   644,   647,   648
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 1
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "STRING", "SYMBOL", "NUMBER", "PP", "SP",
  "\"::\"", "CLASS", "CONST", "ENUM", "PRIVATE", "PROTECTED", "PUBLIC",
  "VIRTUAL", "AUTO", "NCSC_MODULE", "SC_MODULE", "SC_SIGNAL",
  "SC_INOUT_CLK", "SC_CLOCK", "SC_CTOR", "SC_MAIN", "SP_CELL",
  "SP_CELL_DECL", "SP_MODULE_CONTINUED", "SP_PIN", "SP_TEMPLATE",
  "SP_TRACED", "SP_UI", "SP_COVERGROUP", "SP_COVER_SAMPLE", "COVERPOINT",
  "CG_PAGE", "CG_DESCRIPTION", "CG_OPTION", "CG_DEFAULT", "CG_BINS",
  "CG_ILLEGAL_BINS", "CG_ILLEGAL_BINS_FUNC", "CG_IGNORE_BINS",
  "CG_IGNORE_BINS_FUNC", "CG_LIMIT_FUNC", "CG_AUTO_ENUM_BINS", "CG_CROSS",
  "CG_ROWS", "CG_COLS", "CG_TABLE", "CG_WINDOW", "VL_SIG", "VL_SIGW",
  "VL_INOUT", "VL_INOUTW", "VL_IN", "VL_INW", "VL_OUT", "VL_OUTW", "'!'",
  "'\"'", "'#'", "'$'", "'%'", "'&'", "'\\''", "'('", "')'", "'*'", "'+'",
  "','", "'-'", "'.'", "'/'", "':'", "';'", "'<'", "'='", "'>'", "'?'",
  "'@'", "'\\\\'", "'['", "']'", "'^'", "'`'", "'|'", "'{'", "'}'", "'~'",
  "$accept", "sourceText", "symbol", "clAccess", "expList", "exp", "auto",
  "module", "module_continued", "class", "clColList", "clList",
  "clSymAccess", "clSymParamed", "clSymScoped", "clSymRef", "ctor", "cell",
  "cell_decl", "pin", "decl", "pin_template", "string_or_cellname",
  "declType", "declType1", "declTypeBase", "decl_sp_ui", "type_sp_ui",
  "inout", "inout_clk", "inst_clk", "sp", "cpBinNumber", "cpBinRange",
  "cpBinValue", "cpBinValueList", "cpBinType", "cpBinMulti",
  "cpBinMultiNum", "coverpointBin", "coverpointBinList", "cgOpt", "cpOpt",
  "cpOptList", "coverpoint_head", "coverpoint_desc", "cross_item",
  "cross_item_list", "cross_start", "cross_entry", "cross_desc_list",
  "cross_head", "window_head", "window_desc", "coverpoint",
  "coverpointList", "covergroup", "covergroup_head", "coversample",
  "traceable", "enum", "enumSymbol", "enumValList", "enumVal",
  "enumAssign", "enumExpr", "enumFunParmList", "cellname", "vectorsE",
  "vectors_bra", "vector_bra", "vector", "vectorNum", "negNum", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    58,    59,    60,    61,    62,    63,    64,
      92,    91,    93,    94,    96,   124,   123,   125,   126
};
# endif

#define YYPACT_NINF -399

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-399)))

#define YYTABLE_NINF -1

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     315,  -399,  -399,  -399,  -399,  -399,  -399,     8,  -399,    33,
    -399,  -399,  -399,  -399,  -399,  -399,    -4,    -8,    69,    48,
      62,  -399,    81,   100,   102,   117,   119,    28,    95,   181,
     121,  -399,  -399,  -399,  -399,  -399,  -399,  -399,  -399,  -399,
    -399,  -399,  -399,  -399,  -399,  -399,  -399,   130,   135,   136,
     140,   146,   152,   156,   158,  -399,  -399,  -399,  -399,  -399,
    -399,  -399,  -399,  -399,  -399,  -399,  -399,  -399,  -399,  -399,
    -399,  -399,  -399,  -399,  -399,  -399,  -399,  -399,  -399,  -399,
    -399,  -399,  -399,  -399,  -399,  -399,   191,  -399,  -399,   315,
    -399,  -399,  -399,  -399,  -399,  -399,  -399,  -399,  -399,  -399,
    -399,  -399,  -399,  -399,  -399,  -399,  -399,  -399,   166,  -399,
    -399,  -399,   201,  -399,    23,  -399,    19,   236,    28,   160,
      -6,  -399,   238,   239,   240,   242,   239,    82,    27,   246,
     187,  -399,  -399,    37,  -399,   251,   252,   264,   265,   266,
     267,   268,   269,   270,  -399,  -399,   144,   271,  -399,  -399,
    -399,   184,  -399,  -399,  -399,  -399,   203,   274,   213,   204,
      37,   206,  -399,  -399,   216,   202,   215,   218,   219,   220,
    -399,   221,  -399,    28,    37,   160,  -399,   278,  -399,   283,
     222,  -399,   226,   202,   202,   202,   202,   202,   202,   202,
     202,   289,   223,   224,   290,   291,   292,  -399,   -26,   211,
     -30,  -399,   138,  -399,   294,   284,   235,    30,   228,   229,
     234,  -399,   237,   230,  -399,   231,   -38,  -399,  -399,   302,
     227,  -399,  -399,    37,   202,  -399,   304,   239,  -399,   306,
     309,  -399,    11,   330,   312,  -399,    37,   331,   279,   202,
     337,   338,   339,   340,   341,   342,   343,   348,   411,   412,
     344,   351,   352,  -399,   413,   194,  -399,   172,  -399,   217,
    -399,   345,  -399,   354,   336,    30,  -399,  -399,  -399,   212,
     212,  -399,   212,   159,  -399,   274,  -399,   160,  -399,   346,
    -399,  -399,   357,   160,   355,    37,  -399,  -399,  -399,   349,
    -399,    41,    41,    41,    41,    41,    41,    41,    41,   421,
     353,   356,   424,   427,   428,   358,   359,   360,   429,   430,
     433,   362,   435,   365,   366,   367,     3,  -399,    94,  -399,
    -399,  -399,  -399,  -399,   368,  -399,    35,  -399,   105,  -399,
    -399,  -399,  -399,  -399,  -399,   369,   380,  -399,  -399,  -399,
     373,  -399,   374,   381,   446,   375,  -399,   382,   384,   385,
     386,   387,   388,   389,   390,   394,  -399,  -399,   391,   395,
     393,   -29,   460,   461,   392,  -399,  -399,   462,  -399,   463,
     465,   466,     6,    21,    63,   396,   397,  -399,   398,   399,
    -399,   400,  -399,  -399,    25,  -399,  -399,   468,    57,  -399,
      41,    41,    41,    41,    41,    41,    41,    41,  -399,  -399,
    -399,   471,  -399,   401,   217,   402,   404,   474,   415,   416,
     418,   414,   477,  -399,   417,   171,  -399,  -399,   419,   405,
     410,    20,   420,   422,  -399,   485,  -399,  -399,  -399,  -399,
      88,   160,   423,   487,   426,   431,   432,   434,   436,   437,
     438,   439,   440,   490,   116,  -399,  -399,   425,   441,   444,
     445,  -399,   497,  -399,   442,  -399,   443,  -399,  -399,   -36,
    -399,  -399,  -399,  -399,   -33,  -399,   159,   447,  -399,   448,
     449,    37,   450,    37,   451,    37,   452,    37,   500,   454,
     455,  -399,   456,   457,   458,  -399,   171,  -399,    20,   459,
     485,   464,  -399,   467,   469,  -399,   470,  -399,   473,  -399,
     476,  -399,   478,   479,   507,  -399,  -399,  -399,  -399,   453,
    -399,  -399,  -399,  -399,  -399,  -399,   472,   475,   480,   481,
    -399,   482,  -399,  -399,  -399,  -399,  -399,   -24,  -399,   217,
     126,   483,  -399
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,    75,    76,    77,    78,   137,    34,     0,    79,   214,
      36,    37,    35,    82,    84,    83,     0,     0,     0,     0,
       0,    86,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,     0,     0,     0,
       0,     0,     0,     0,     0,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,     0,    80,    81,     2,
      38,    40,    41,    42,    73,    43,    44,    45,    46,    66,
      47,    72,   131,    68,    69,    70,    71,    48,     0,    65,
      67,    74,   108,    97,     0,   213,     0,     0,     0,   233,
       0,   135,     0,     0,     0,     0,     0,     0,   127,     0,
     123,   125,   128,     0,   200,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     1,    39,     0,     0,    96,    95,
      93,     0,    91,    92,    88,    94,     0,     0,     0,     0,
       0,     0,   136,   134,     0,   226,     0,     0,     0,     0,
     121,     0,   122,     0,     0,   233,   124,   235,   238,     0,
       0,   236,     0,   228,   228,   228,   228,   228,   228,   228,
     228,     0,     0,     0,     0,     0,     0,   196,     0,     0,
       0,   197,     0,   109,     0,    35,     0,     0,     0,    98,
     100,   102,   110,   106,   212,   219,     0,   215,    85,     0,
       0,   133,   114,     0,   227,   230,     0,     0,    87,     0,
       0,   126,     0,     0,     0,   239,     0,     0,     0,   229,
       0,     0,     0,     0,     0,     0,     0,   170,     0,     0,
       0,   188,     0,   172,     0,     0,   193,     0,   191,     0,
     195,     0,   198,   112,     0,     0,   104,   103,    89,     0,
       0,   111,     0,     0,   217,     0,   211,   233,   234,     0,
     231,   115,     0,   233,     0,     0,   129,   202,   237,     0,
     201,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   157,     0,   156,
     181,   182,   183,   185,     0,   186,     0,   168,     0,   199,
     113,    90,   105,    99,   101,     0,   221,   220,   218,   216,
       0,   232,     0,     0,     0,     0,   132,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   161,   159,     0,     0,
       0,     0,     0,     0,     0,   145,   146,     0,   147,     0,
       0,     0,     0,     0,     0,     0,     0,   158,     0,     0,
     187,     0,   169,   107,     0,   118,   116,     0,     0,   130,
       0,     0,     0,     0,     0,     0,     0,     0,   171,   160,
     189,     0,   173,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   138,     0,     0,   141,   142,     0,     0,
       0,     0,     0,     0,   177,     0,   194,   192,   222,   224,
       0,   233,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   164,   162,     0,     0,     0,
       0,   155,     0,   150,     0,   151,     0,   148,   143,     0,
     153,   154,   178,   179,     0,   223,     0,     0,   119,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   163,     0,     0,     0,   139,     0,   149,     0,     0,
       0,     0,   225,     0,     0,   203,     0,   205,     0,   207,
       0,   209,     0,     0,     0,   174,   167,   166,   165,     0,
     144,   152,   180,   184,   117,   120,     0,     0,     0,     0,
     190,     0,   140,   204,   206,   208,   210,     0,   175,     0,
       0,     0,   176
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -399,  -399,  -399,     4,  -399,   484,  -399,  -399,  -399,  -399,
     247,  -117,  -399,  -141,    -2,  -399,  -399,  -399,  -399,  -399,
    -399,  -399,  -399,   403,   347,  -399,  -399,     9,  -399,  -399,
    -399,  -399,  -387,  -232,  -382,  -399,  -399,  -399,  -399,   199,
    -399,  -399,  -254,  -398,  -399,  -399,    32,  -399,  -399,   192,
    -399,  -399,  -399,  -399,   326,  -399,  -399,  -399,  -399,  -399,
    -399,  -399,  -399,   259,  -399,  -371,  -399,  -119,    77,   372,
    -186,  -173,  -160,  -276
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    86,    87,   207,    89,    90,    91,    92,    93,    94,
     208,   209,   210,   211,   212,   213,    95,    96,    97,    98,
      99,   100,   171,   129,   130,   131,   101,   132,   103,   104,
     105,   106,   416,   417,   418,   459,   316,   374,   375,   317,
     318,   197,   327,   328,   198,   256,   463,   464,   324,   325,
     326,   199,   200,   260,   201,   202,   107,   108,   109,   110,
     111,   116,   216,   217,   274,   338,   430,   166,   238,   239,
     225,   161,   180,   181
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_uint16 yytable[] =
{
     220,   319,   233,   323,    88,   114,   444,   169,   172,   102,
     412,   413,   112,   429,   232,   347,   348,   349,   350,   351,
     352,   353,   354,   156,   412,   413,   419,   112,   454,   336,
     337,   275,   128,   488,   112,   173,   490,   115,   280,   458,
     204,   177,   178,   414,   258,   402,   178,   403,   253,   276,
     528,   489,   120,   280,   491,   254,   259,   404,    28,   162,
     255,   117,   529,   279,   319,   266,   267,   118,   163,   306,
     307,   308,   323,   119,   382,   311,   289,   313,   314,   372,
     285,   320,   321,   322,   373,   170,   165,   415,   286,   148,
     149,   428,   150,    88,   113,   492,   151,   152,   102,   509,
     153,   415,   174,   420,   340,   157,   510,   179,   282,   154,
     343,   179,   155,   121,   434,   435,   436,   437,   438,   439,
     440,   441,   379,   432,   332,   345,   433,   122,   306,   307,
     308,   530,   309,   310,   311,   312,   313,   314,   315,   306,
     307,   308,   422,   423,   415,   311,   123,   313,   314,   421,
     306,   307,   308,   334,   465,   335,   311,   466,   313,   314,
     306,   307,   308,   336,   337,   124,   311,   125,   313,   314,
     133,   191,   192,   193,   194,   412,   413,   191,   192,   193,
     194,   376,   126,   195,   127,   134,   135,   196,   112,   195,
     382,   144,   381,   196,   204,   136,    10,    11,   205,   206,
     137,   138,   263,   480,   261,   139,   306,   307,   308,   147,
     265,   140,   311,   531,   313,   314,   112,   141,   320,   321,
     322,   142,   204,   143,    10,    11,    12,   206,   306,   307,
     308,   146,   309,   310,   311,   312,   313,   314,   315,   112,
     158,   160,   164,   165,   167,   204,   168,    10,    11,    12,
     175,   306,   307,   308,   176,   182,   183,   311,   467,   313,
     314,   240,   241,   242,   243,   244,   245,   246,   184,   185,
     186,   187,   188,   189,   190,   203,   382,   214,   215,   218,
     221,   219,   222,   223,   226,   228,   234,   227,   235,   229,
     230,   236,   237,   247,   250,   251,   252,   257,   112,   248,
     249,   264,   269,   270,   271,   272,   277,   273,   281,   278,
     283,   496,   284,   498,   268,   500,   288,   502,     1,     2,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,   291,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,   287,   290,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   303,   304,   305,   329,
     302,   330,   331,   342,   344,   355,   346,   356,   341,   358,
     357,   359,   360,   364,   365,   362,   363,   366,   367,   368,
     361,   369,   370,   371,   378,   384,   383,   385,   386,   388,
     387,   390,   389,   391,   392,   393,   394,   395,   396,   397,
     398,   400,   401,   405,   406,   399,   408,   409,   407,   410,
     411,   424,   431,   426,   427,   442,   445,   415,   446,   447,
     448,   449,   443,   450,   425,   452,   457,   456,   451,   462,
     469,   453,   470,   455,   460,   479,   461,   468,   472,   481,
     471,   485,   474,   473,   476,   503,   475,   482,   477,   478,
     483,   484,   521,   493,   494,   486,   333,   377,   380,   487,
     231,   159,   512,   495,   497,   499,   501,   504,   262,   505,
     506,   507,   508,   511,   339,   522,   516,   224,   513,   517,
       0,   514,   518,   515,   519,   520,   523,     0,     0,   524,
       0,     0,     0,     0,   525,   526,     0,   532,     0,     0,
       0,     0,     0,     0,   527,     0,     0,     0,     0,     0,
       0,     0,     0,   145
};

static const yytype_int16 yycheck[] =
{
     160,   255,   175,   257,     0,     7,   404,   126,   127,     0,
       4,     5,     4,   384,   174,   291,   292,   293,   294,   295,
     296,   297,   298,     4,     4,     5,     5,     4,   415,     4,
       5,    69,     4,    69,     4,     8,    69,     4,   224,   421,
      10,     4,     5,    37,    74,    74,     5,    76,    74,    87,
      74,    87,     4,   239,    87,    81,    86,    86,    30,    65,
      86,    65,    86,   223,   318,   206,   207,    75,    74,    34,
      35,    36,   326,     4,   328,    40,   236,    42,    43,    76,
      69,    46,    47,    48,    81,     3,     4,    81,    77,    66,
      67,    66,    69,    89,    86,   466,    73,    74,    89,   486,
      77,    81,    75,    82,   277,    86,   488,    70,   227,    86,
     283,    70,   114,    65,   390,   391,   392,   393,   394,   395,
     396,   397,    87,    66,   265,   285,    69,    65,    34,    35,
      36,   529,    38,    39,    40,    41,    42,    43,    44,    34,
      35,    36,   374,   375,    81,    40,    65,    42,    43,    86,
      34,    35,    36,   270,    66,   272,    40,    69,    42,    43,
      34,    35,    36,     4,     5,    65,    40,    65,    42,    43,
      75,    33,    34,    35,    36,     4,     5,    33,    34,    35,
      36,    87,    65,    45,    65,     4,    65,    49,     4,    45,
     444,     0,    87,    49,    10,    65,    12,    13,    14,    15,
      65,    65,   204,    87,    66,    65,    34,    35,    36,     8,
     206,    65,    40,    87,    42,    43,     4,    65,    46,    47,
      48,    65,    10,    65,    12,    13,    14,    15,    34,    35,
      36,    65,    38,    39,    40,    41,    42,    43,    44,     4,
       4,    81,     4,     4,     4,    10,     4,    12,    13,    14,
       4,    34,    35,    36,    67,     4,     4,    40,   431,    42,
      43,   184,   185,   186,   187,   188,   189,   190,     4,     4,
       4,     4,     4,     4,     4,     4,   530,    74,     4,    66,
      74,    77,    66,    81,    69,    66,     8,    69,     5,    69,
      69,    69,    66,     4,     4,     4,     4,    86,     4,    76,
      76,    17,    73,    69,    67,    75,     4,    76,     4,    82,
       4,   471,     3,   473,    86,   475,     4,   477,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    69,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    74,    74,    69,    69,    69,    69,
      69,    69,    69,    65,     3,     3,    65,    65,     5,    74,
      76,    67,    86,    66,    69,     4,    77,    74,    82,     5,
      74,     4,     4,     4,     4,    76,    76,     4,    76,     4,
      82,    76,    76,    76,    76,    65,    77,    74,    74,     3,
      69,    69,    77,    69,    69,    69,    69,    69,    69,    69,
      66,    66,    69,     3,     3,    74,     4,     4,    76,     4,
       4,    74,     4,    74,    74,     4,    74,    81,    74,     5,
      65,    65,    81,    65,    86,     8,    76,    82,    74,     4,
       3,    74,    66,    74,    74,     5,    74,    74,    66,    74,
      69,     4,    66,    69,    66,     5,    69,    66,    69,    69,
      66,    66,     5,    66,    66,    73,   269,   318,   326,    76,
     173,   118,   490,    74,    74,    74,    74,    73,   202,    74,
      74,    74,    74,    74,   275,    82,    66,   165,    74,    66,
      -1,    74,    66,    74,    66,    66,    74,    -1,    -1,    74,
      -1,    -1,    -1,    -1,    74,    74,    -1,    74,    -1,    -1,
      -1,    -1,    -1,    -1,    82,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    89
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    90,    91,    92,    93,
      94,    95,    96,    97,    98,   105,   106,   107,   108,   109,
     110,   115,   116,   117,   118,   119,   120,   145,   146,   147,
     148,   149,     4,    86,   103,     4,   150,    65,    75,     4,
       4,    65,    65,    65,    65,    65,    65,    65,     4,   112,
     113,   114,   116,    75,     4,    65,    65,    65,    65,    65,
      65,    65,    65,    65,     0,    94,    65,     8,    66,    67,
      69,    73,    74,    77,    86,   103,     4,    86,     4,   112,
      81,   160,    65,    74,     4,     4,   156,     4,     4,   156,
       3,   111,   156,     8,    75,     4,    67,     4,     5,    70,
     161,   162,     4,     4,     4,     4,     4,     4,     4,     4,
       4,    33,    34,    35,    36,    45,    49,   130,   133,   140,
     141,   143,   144,     4,    10,    14,    15,    92,    99,   100,
     101,   102,   103,   104,    74,     4,   151,   152,    66,    77,
     161,    74,    66,    81,   158,   159,    69,    69,    66,    69,
      69,   113,   161,   160,     8,     5,    69,    66,   157,   158,
     157,   157,   157,   157,   157,   157,   157,     4,    76,    76,
       4,     4,     4,    74,    81,    86,   134,    86,    74,    86,
     142,    66,   143,   103,    17,    92,   102,   102,    86,    73,
      69,    67,    75,    76,   153,    69,    87,     4,    82,   161,
     159,     4,   156,     4,     3,    69,    77,    74,     4,   161,
      74,    69,    69,    69,    69,    69,    69,    69,    69,    65,
       3,     3,    76,    65,    65,     5,    34,    35,    36,    38,
      39,    40,    41,    42,    43,    44,   125,   128,   129,   131,
      46,    47,    48,   131,   137,   138,   139,   131,   132,    74,
      67,    86,   102,    99,   100,   100,     4,     5,   154,   152,
     160,    82,    66,   160,    69,   161,    77,   162,   162,   162,
     162,   162,   162,   162,   162,     4,    74,    74,     5,     4,
       4,    82,    76,    76,     4,     4,     4,    76,     4,    76,
      76,    76,    76,    81,   126,   127,    87,   128,    76,    87,
     138,    87,   131,    77,    65,    74,    74,    69,     3,    77,
      69,    69,    69,    69,    69,    69,    69,    69,    66,    74,
      66,    69,    74,    76,    86,     3,     3,    76,     4,     4,
       4,     4,     4,     5,    37,    81,   121,   122,   123,     5,
      82,    86,   122,   122,    74,    86,    74,    74,    66,   154,
     155,     4,    66,    69,   162,   162,   162,   162,   162,   162,
     162,   162,     4,    81,   132,    74,    74,     5,    65,    65,
      65,    74,     8,    74,   121,    74,    82,    76,   123,   124,
      74,    74,     4,   135,   136,    66,    69,   160,    74,     3,
      66,    69,    66,    69,    66,    69,    66,    69,    69,     5,
      87,    74,    66,    66,    66,     4,    73,    76,    69,    87,
      69,    87,   154,    66,    66,    74,   161,    74,   161,    74,
     161,    74,   161,     5,    73,    74,    74,    74,    74,   121,
     123,    74,   135,    74,    74,    74,    66,    66,    66,    66,
      66,     5,    82,    74,    74,    74,    74,    82,    74,    86,
     132,    87,    74
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    89,    90,    91,    91,    91,    91,    91,    91,    91,
      91,    91,    91,    91,    91,    91,    91,    91,    91,    91,
      91,    91,    91,    91,    91,    91,    91,    91,    91,    91,
      91,    91,    91,    91,    91,    92,    92,    92,    93,    93,
      94,    94,    94,    94,    94,    94,    94,    94,    94,    94,
      94,    94,    94,    94,    94,    94,    94,    94,    94,    94,
      94,    94,    94,    94,    94,    94,    94,    94,    94,    94,
      94,    94,    94,    94,    94,    94,    94,    94,    94,    94,
      94,    94,    94,    94,    95,    96,    96,    97,    98,    98,
      98,    98,    98,    98,    98,    98,    98,    98,    99,    99,
     100,   100,   101,   101,   101,   101,   102,   102,   103,   103,
     104,   104,   104,   104,   105,   106,   107,   108,   109,   110,
     110,   111,   111,   112,   112,   113,   113,   114,   114,   114,
     114,   115,   116,   117,   118,   119,   119,   120,   121,   121,
     122,   123,   123,   124,   124,   125,   125,   125,   126,   127,
     128,   128,   128,   128,   128,   128,   128,   129,   129,   130,
     130,   130,   131,   131,   131,   131,   131,   131,   132,   132,
     133,   133,   134,   134,   134,   134,   134,   134,   135,   136,
     136,   137,   137,   137,   138,   138,   139,   139,   140,   140,
     141,   142,   142,   143,   143,   143,   143,   144,   144,   145,
     146,   147,   148,   148,   148,   148,   148,   148,   148,   148,
     148,   149,   149,   150,   150,   151,   151,   152,   153,   153,
     154,   154,   154,   154,   155,   155,   156,   156,   157,   157,
     158,   158,   159,   160,   160,   161,   161,   161,   162,   162
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     4,     1,     4,     3,     5,
       6,     3,     3,     3,     3,     3,     3,     2,     1,     3,
       1,     3,     1,     2,     2,     3,     1,     4,     1,     3,
       1,     2,     2,     3,     4,     5,     7,    11,     7,     9,
      11,     1,     1,     1,     2,     1,     3,     1,     1,     4,
       6,     1,     6,     4,     3,     2,     3,     1,     1,     3,
       5,     1,     1,     1,     3,     2,     2,     2,     3,     4,
       4,     4,     6,     4,     4,     4,     1,     1,     2,     4,
       5,     4,     4,     5,     4,     6,     6,     6,     1,     2,
       2,     5,     1,     4,     7,    10,    13,     4,     1,     1,
       3,     1,     1,     1,     6,     1,     1,     2,     2,     5,
       9,     1,     4,     2,     5,     2,     1,     1,     2,     5,
       2,     5,     5,    10,    12,    10,    12,    10,    12,    10,
      12,     5,     4,     1,     0,     1,     3,     2,     2,     0,
       1,     1,     3,     4,     1,     3,     1,     2,     0,     1,
       1,     2,     3,     0,     3,     1,     1,     3,     1,     2
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
// YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 203 "scgrammer.y" /* yacc.c:1646  */
    { /*clean up!*/ scparser_EmitPrefix(); }
#line 1764 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 37:
#line 217 "scgrammer.y" /* yacc.c:1646  */
    { }
#line 1770 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 38:
#line 222 "scgrammer.y" /* yacc.c:1646  */
    { }
#line 1776 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 39:
#line 223 "scgrammer.y" /* yacc.c:1646  */
    { }
#line 1782 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 40:
#line 226 "scgrammer.y" /* yacc.c:1646  */
    { }
#line 1788 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 41:
#line 227 "scgrammer.y" /* yacc.c:1646  */
    { }
#line 1794 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 42:
#line 228 "scgrammer.y" /* yacc.c:1646  */
    { }
#line 1800 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 43:
#line 229 "scgrammer.y" /* yacc.c:1646  */
    { }
#line 1806 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 44:
#line 230 "scgrammer.y" /* yacc.c:1646  */
    { }
#line 1812 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 45:
#line 231 "scgrammer.y" /* yacc.c:1646  */
    { }
#line 1818 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 46:
#line 232 "scgrammer.y" /* yacc.c:1646  */
    { }
#line 1824 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 47:
#line 233 "scgrammer.y" /* yacc.c:1646  */
    { }
#line 1830 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 48:
#line 234 "scgrammer.y" /* yacc.c:1646  */
    { }
#line 1836 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 49:
#line 235 "scgrammer.y" /* yacc.c:1646  */
    { }
#line 1842 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 50:
#line 236 "scgrammer.y" /* yacc.c:1646  */
    { }
#line 1848 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 51:
#line 237 "scgrammer.y" /* yacc.c:1646  */
    { }
#line 1854 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 52:
#line 238 "scgrammer.y" /* yacc.c:1646  */
    { }
#line 1860 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 53:
#line 239 "scgrammer.y" /* yacc.c:1646  */
    { }
#line 1866 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 54:
#line 240 "scgrammer.y" /* yacc.c:1646  */
    { }
#line 1872 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 55:
#line 241 "scgrammer.y" /* yacc.c:1646  */
    { }
#line 1878 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 56:
#line 242 "scgrammer.y" /* yacc.c:1646  */
    { }
#line 1884 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 57:
#line 243 "scgrammer.y" /* yacc.c:1646  */
    { }
#line 1890 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 58:
#line 244 "scgrammer.y" /* yacc.c:1646  */
    { }
#line 1896 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 59:
#line 245 "scgrammer.y" /* yacc.c:1646  */
    { }
#line 1902 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 60:
#line 246 "scgrammer.y" /* yacc.c:1646  */
    { }
#line 1908 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 61:
#line 247 "scgrammer.y" /* yacc.c:1646  */
    { }
#line 1914 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 62:
#line 248 "scgrammer.y" /* yacc.c:1646  */
    { }
#line 1920 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 63:
#line 249 "scgrammer.y" /* yacc.c:1646  */
    { }
#line 1926 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 64:
#line 250 "scgrammer.y" /* yacc.c:1646  */
    { }
#line 1932 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 65:
#line 251 "scgrammer.y" /* yacc.c:1646  */
    { }
#line 1938 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 66:
#line 252 "scgrammer.y" /* yacc.c:1646  */
    { }
#line 1944 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 67:
#line 253 "scgrammer.y" /* yacc.c:1646  */
    { }
#line 1950 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 68:
#line 254 "scgrammer.y" /* yacc.c:1646  */
    { }
#line 1956 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 69:
#line 255 "scgrammer.y" /* yacc.c:1646  */
    { }
#line 1962 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 70:
#line 256 "scgrammer.y" /* yacc.c:1646  */
    { }
#line 1968 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 71:
#line 257 "scgrammer.y" /* yacc.c:1646  */
    { }
#line 1974 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 72:
#line 258 "scgrammer.y" /* yacc.c:1646  */
    { }
#line 1980 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 73:
#line 259 "scgrammer.y" /* yacc.c:1646  */
    { }
#line 1986 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 74:
#line 260 "scgrammer.y" /* yacc.c:1646  */
    { }
#line 1992 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 75:
#line 261 "scgrammer.y" /* yacc.c:1646  */
    { SCFree((yyvsp[0].string)); }
#line 1998 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 76:
#line 262 "scgrammer.y" /* yacc.c:1646  */
    { scparser_symbol((yyvsp[0].string)); SCFree((yyvsp[0].string)); }
#line 2004 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 77:
#line 263 "scgrammer.y" /* yacc.c:1646  */
    { SCFree((yyvsp[0].string)); }
#line 2010 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 78:
#line 264 "scgrammer.y" /* yacc.c:1646  */
    { }
#line 2016 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 79:
#line 265 "scgrammer.y" /* yacc.c:1646  */
    { }
#line 2022 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 80:
#line 266 "scgrammer.y" /* yacc.c:1646  */
    { }
#line 2028 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 81:
#line 267 "scgrammer.y" /* yacc.c:1646  */
    { }
#line 2034 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 82:
#line 268 "scgrammer.y" /* yacc.c:1646  */
    { }
#line 2040 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 83:
#line 269 "scgrammer.y" /* yacc.c:1646  */
    { }
#line 2046 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 84:
#line 272 "scgrammer.y" /* yacc.c:1646  */
    {
			  scparser_EmitPrefix();
			  scparser_PrefixCat(sclextext,sclexleng);  /* Emit as independent TEXT */
			  scparser_call(1,"auto",sclextext);
			}
#line 2056 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 85:
#line 279 "scgrammer.y" /* yacc.c:1646  */
    { scparser_call(-1,"module",(yyvsp[-1].string)); }
#line 2062 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 86:
#line 280 "scgrammer.y" /* yacc.c:1646  */
    { scparser_call(1,"module","sc_main"); }
#line 2068 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 87:
#line 283 "scgrammer.y" /* yacc.c:1646  */
    { scparser_call(-1,"module_continued",(yyvsp[-1].string)); }
#line 2074 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 88:
#line 286 "scgrammer.y" /* yacc.c:1646  */
    { scparser_call(-1,"class",(yyvsp[-1].string)); }
#line 2080 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 89:
#line 287 "scgrammer.y" /* yacc.c:1646  */
    { scparser_call(-2,"class",(yyvsp[-3].string),(yyvsp[-1].string)); }
#line 2086 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 90:
#line 288 "scgrammer.y" /* yacc.c:1646  */
    { scparser_call(-1,"module",(yyvsp[-4].string)); }
#line 2092 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 91:
#line 289 "scgrammer.y" /* yacc.c:1646  */
    { }
#line 2098 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 92:
#line 290 "scgrammer.y" /* yacc.c:1646  */
    { }
#line 2104 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 93:
#line 291 "scgrammer.y" /* yacc.c:1646  */
    { }
#line 2110 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 94:
#line 292 "scgrammer.y" /* yacc.c:1646  */
    { }
#line 2116 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 95:
#line 293 "scgrammer.y" /* yacc.c:1646  */
    { }
#line 2122 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 96:
#line 294 "scgrammer.y" /* yacc.c:1646  */
    { }
#line 2128 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 97:
#line 295 "scgrammer.y" /* yacc.c:1646  */
    { }
#line 2134 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 98:
#line 298 "scgrammer.y" /* yacc.c:1646  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2140 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 99:
#line 299 "scgrammer.y" /* yacc.c:1646  */
    { (yyval.string) = scstrjoin3sis ((yyvsp[-2].string),":",(yyvsp[0].string)); }
#line 2146 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 100:
#line 302 "scgrammer.y" /* yacc.c:1646  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2152 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 101:
#line 303 "scgrammer.y" /* yacc.c:1646  */
    { (yyval.string) = scstrjoin3sis ((yyvsp[-2].string),",",(yyvsp[0].string)); }
#line 2158 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 102:
#line 306 "scgrammer.y" /* yacc.c:1646  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2164 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 103:
#line 307 "scgrammer.y" /* yacc.c:1646  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2170 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 104:
#line 308 "scgrammer.y" /* yacc.c:1646  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2176 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 105:
#line 309 "scgrammer.y" /* yacc.c:1646  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2182 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 106:
#line 312 "scgrammer.y" /* yacc.c:1646  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2188 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 107:
#line 313 "scgrammer.y" /* yacc.c:1646  */
    { (yyval.string) = scstrjoin4sisi ((yyvsp[-3].string),"<",(yyvsp[-1].string),">"); }
#line 2194 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 108:
#line 316 "scgrammer.y" /* yacc.c:1646  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2200 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 109:
#line 317 "scgrammer.y" /* yacc.c:1646  */
    { (yyval.string) = scstrjoin3sis ((yyvsp[-2].string),"::",(yyvsp[0].string)); }
#line 2206 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 110:
#line 320 "scgrammer.y" /* yacc.c:1646  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2212 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 111:
#line 321 "scgrammer.y" /* yacc.c:1646  */
    { (yyval.string) = scstrjoin2si ((yyvsp[-1].string),"*"); }
#line 2218 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 112:
#line 322 "scgrammer.y" /* yacc.c:1646  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2224 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 113:
#line 323 "scgrammer.y" /* yacc.c:1646  */
    { (yyval.string) = scstrjoin2si ((yyvsp[-1].string),"*"); }
#line 2230 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 114:
#line 326 "scgrammer.y" /* yacc.c:1646  */
    { scparser_call(-1,"ctor",(yyvsp[-1].string)); }
#line 2236 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 115:
#line 330 "scgrammer.y" /* yacc.c:1646  */
    { scparser_call(-2,"cell",(yyvsp[-2].string),(yyvsp[0].string)); }
#line 2242 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 116:
#line 333 "scgrammer.y" /* yacc.c:1646  */
    { scparser_call(-2,"cell_decl",(yyvsp[-4].string),(yyvsp[-2].string)); }
#line 2248 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 117:
#line 336 "scgrammer.y" /* yacc.c:1646  */
    { scparser_call(-5,"pin",(yyvsp[-8].string),(yyvsp[-6].string),(yyvsp[-5].string),(yyvsp[-3].string),(yyvsp[-2].string)); }
#line 2254 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 118:
#line 339 "scgrammer.y" /* yacc.c:1646  */
    { scparser_call(-4,"signal",(yyvsp[-6].string),(yyvsp[-4].string),(yyvsp[-2].string),(yyvsp[-1].string)); }
#line 2260 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 119:
#line 343 "scgrammer.y" /* yacc.c:1646  */
    { scparser_call(-3,"pin_template",(yyvsp[-6].string),(yyvsp[-4].string),(yyvsp[-2].string)); }
#line 2266 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 120:
#line 345 "scgrammer.y" /* yacc.c:1646  */
    { scparser_call(-4,"pin_template",(yyvsp[-8].string),(yyvsp[-6].string),(yyvsp[-4].string),(yyvsp[-2].string)); }
#line 2272 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 121:
#line 348 "scgrammer.y" /* yacc.c:1646  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2278 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 122:
#line 349 "scgrammer.y" /* yacc.c:1646  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2284 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 123:
#line 353 "scgrammer.y" /* yacc.c:1646  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2290 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 124:
#line 354 "scgrammer.y" /* yacc.c:1646  */
    { char *cp=malloc(strlen((yyvsp[-1].string))+5);
			  strcpy (cp,(yyvsp[-1].string)); strcat(cp,"*");
			  SCFree ((yyvsp[-1].string));
			  (yyval.string)=cp; }
#line 2299 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 125:
#line 360 "scgrammer.y" /* yacc.c:1646  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2305 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 126:
#line 361 "scgrammer.y" /* yacc.c:1646  */
    { (yyval.string) = scstrjoin3sis ((yyvsp[-2].string),"::",(yyvsp[0].string)); }
#line 2311 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 127:
#line 365 "scgrammer.y" /* yacc.c:1646  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2317 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 128:
#line 366 "scgrammer.y" /* yacc.c:1646  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2323 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 129:
#line 367 "scgrammer.y" /* yacc.c:1646  */
    { char *cp=malloc(strlen((yyvsp[-3].string))+strlen((yyvsp[-1].string))+5);
						  strcpy(cp,(yyvsp[-3].string)); strcat(cp,"<");strcat(cp,(yyvsp[-1].string));strcat(cp,">");
						  SCFree ((yyvsp[-3].string)); SCFree ((yyvsp[-1].string));
						  (yyval.string)=cp; }
#line 2332 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 130:
#line 371 "scgrammer.y" /* yacc.c:1646  */
    {
						  char *cp=malloc(strlen((yyvsp[-5].string))+strlen((yyvsp[-3].string))+strlen((yyvsp[-1].string))+6);
						  strcpy(cp,(yyvsp[-5].string));  strcat(cp,"<"); strcat(cp,(yyvsp[-3].string));
						  strcat(cp,","); strcat(cp,(yyvsp[-1].string));  strcat(cp,">");
						  SCFree ((yyvsp[-5].string)); SCFree ((yyvsp[-3].string)); SCFree ((yyvsp[-1].string));
						  (yyval.string)=cp; }
#line 2343 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 131:
#line 380 "scgrammer.y" /* yacc.c:1646  */
    { scparser_call(-1,"var_decl",(yyvsp[0].string)); }
#line 2349 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 132:
#line 383 "scgrammer.y" /* yacc.c:1646  */
    {
						  char *cp=malloc(6+strlen((yyvsp[-3].string))+strlen((yyvsp[-1].string))+6);
						  strcpy(cp,"sp_ui<");  strcat(cp,(yyvsp[-3].string));
						  strcat(cp,","); strcat(cp,(yyvsp[-1].string));  strcat(cp,">");
						  SCFree ((yyvsp[-3].string)); SCFree ((yyvsp[-1].string));
						  (yyval.string)=cp; }
#line 2360 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 133:
#line 392 "scgrammer.y" /* yacc.c:1646  */
    {
						  {char *cp = strrchr((yyvsp[-3].string),'_'); if (cp) *cp='\0';} /* Drop _clk */
						  scparser_call(4,"signal",(yyvsp[-3].string),"sc_clock",(yyvsp[-2].string),(yyvsp[-1].string));
						  SCFree((yyvsp[-3].string)); SCFree((yyvsp[-2].string)); SCFree((yyvsp[-1].string));}
#line 2369 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 134:
#line 398 "scgrammer.y" /* yacc.c:1646  */
    {
						  scparser_call(3,"signal",(yyvsp[-2].string),"sc_clock",(yyvsp[-1].string));
						  SCFree((yyvsp[-2].string)); SCFree((yyvsp[-1].string));}
#line 2377 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 135:
#line 404 "scgrammer.y" /* yacc.c:1646  */
    { SCFree((yyvsp[-1].string)); }
#line 2383 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 136:
#line 405 "scgrammer.y" /* yacc.c:1646  */
    { SCFree((yyvsp[-2].string)); scparser_symbol((yyvsp[-1].string)); SCFree((yyvsp[-1].string));}
#line 2389 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 137:
#line 408 "scgrammer.y" /* yacc.c:1646  */
    { scparser_call(1,"preproc_sp",sclextext);}
#line 2395 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 138:
#line 418 "scgrammer.y" /* yacc.c:1646  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2401 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 139:
#line 419 "scgrammer.y" /* yacc.c:1646  */
    { (yyval.string) = scstrjoin3sis ((yyvsp[-2].string),"::",(yyvsp[0].string)); }
#line 2407 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 140:
#line 422 "scgrammer.y" /* yacc.c:1646  */
    { scparser_call(3,"coverpoint","binrange", (yyvsp[-3].string), (yyvsp[-1].string)); SCFree((yyvsp[-3].string)); SCFree((yyvsp[-1].string)); }
#line 2413 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 141:
#line 425 "scgrammer.y" /* yacc.c:1646  */
    { scparser_call(2,"coverpoint","binval", (yyvsp[0].string)); SCFree((yyvsp[0].string)); }
#line 2419 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 142:
#line 426 "scgrammer.y" /* yacc.c:1646  */
    { }
#line 2425 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 143:
#line 429 "scgrammer.y" /* yacc.c:1646  */
    { }
#line 2431 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 144:
#line 430 "scgrammer.y" /* yacc.c:1646  */
    { }
#line 2437 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 145:
#line 433 "scgrammer.y" /* yacc.c:1646  */
    { scparser_call(2,"coverpoint","normal", (yyvsp[0].string)); SCFree((yyvsp[0].string)); }
#line 2443 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 146:
#line 434 "scgrammer.y" /* yacc.c:1646  */
    { scparser_call(2,"coverpoint","illegal", (yyvsp[0].string)); SCFree((yyvsp[0].string)); }
#line 2449 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 147:
#line 435 "scgrammer.y" /* yacc.c:1646  */
    { scparser_call(2,"coverpoint","ignore", (yyvsp[0].string)); SCFree((yyvsp[0].string)); }
#line 2455 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 148:
#line 438 "scgrammer.y" /* yacc.c:1646  */
    { scparser_call(1,"coverpoint","multi_begin"); }
#line 2461 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 149:
#line 441 "scgrammer.y" /* yacc.c:1646  */
    { scparser_call(2,"coverpoint","multi_begin_num",(yyvsp[-2].string)); SCFree((yyvsp[-2].string));}
#line 2467 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 150:
#line 445 "scgrammer.y" /* yacc.c:1646  */
    { scparser_call(1,"coverpoint","default"); }
#line 2473 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 151:
#line 446 "scgrammer.y" /* yacc.c:1646  */
    { scparser_call(1,"coverpoint","single"); }
#line 2479 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 152:
#line 447 "scgrammer.y" /* yacc.c:1646  */
    { scparser_call(1,"coverpoint","multi_end"); }
#line 2485 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 153:
#line 448 "scgrammer.y" /* yacc.c:1646  */
    { scparser_call(1,"coverpoint","multi_auto_end"); }
#line 2491 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 154:
#line 449 "scgrammer.y" /* yacc.c:1646  */
    { scparser_call(1,"coverpoint","multi_auto_end"); }
#line 2497 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 155:
#line 450 "scgrammer.y" /* yacc.c:1646  */
    { scparser_call(2,"coverpoint","enum", (yyvsp[-1].string)); SCFree((yyvsp[-1].string)); }
#line 2503 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 156:
#line 451 "scgrammer.y" /* yacc.c:1646  */
    { }
#line 2509 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 157:
#line 454 "scgrammer.y" /* yacc.c:1646  */
    { }
#line 2515 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 158:
#line 455 "scgrammer.y" /* yacc.c:1646  */
    { }
#line 2521 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 159:
#line 462 "scgrammer.y" /* yacc.c:1646  */
    { scparser_call(1,"covergroup_description",(yyvsp[-1].string)); SCFree((yyvsp[-1].string));}
#line 2527 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 160:
#line 463 "scgrammer.y" /* yacc.c:1646  */
    { scparser_call(2,"covergroup_option",(yyvsp[-3].string),(yyvsp[-1].string)); SCFree((yyvsp[-3].string)); SCFree((yyvsp[-1].string));}
#line 2533 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 161:
#line 464 "scgrammer.y" /* yacc.c:1646  */
    { scparser_call(1,"covergroup_page",(yyvsp[-1].string)); SCFree((yyvsp[-1].string));}
#line 2539 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 162:
#line 468 "scgrammer.y" /* yacc.c:1646  */
    { scparser_call(2,"coverpoint","description",(yyvsp[-1].string)); SCFree((yyvsp[-1].string));}
#line 2545 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 163:
#line 469 "scgrammer.y" /* yacc.c:1646  */
    { scparser_call(3,"coverpoint", "option",(yyvsp[-3].string),(yyvsp[-1].string)); SCFree((yyvsp[-3].string)); SCFree((yyvsp[-1].string));}
#line 2551 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 164:
#line 470 "scgrammer.y" /* yacc.c:1646  */
    { scparser_call(2,"coverpoint","page",(yyvsp[-1].string)); SCFree((yyvsp[-1].string));}
#line 2557 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 165:
#line 471 "scgrammer.y" /* yacc.c:1646  */
    { scparser_call(2,"coverpoint","limit_func", (yyvsp[-3].string)); SCFree((yyvsp[-3].string)); }
#line 2563 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 166:
#line 472 "scgrammer.y" /* yacc.c:1646  */
    { scparser_call(2,"coverpoint","ignore_func", (yyvsp[-3].string)); SCFree((yyvsp[-3].string)); }
#line 2569 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 167:
#line 473 "scgrammer.y" /* yacc.c:1646  */
    { scparser_call(2,"coverpoint","illegal_func", (yyvsp[-3].string)); SCFree((yyvsp[-3].string)); }
#line 2575 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 168:
#line 476 "scgrammer.y" /* yacc.c:1646  */
    { }
#line 2581 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 169:
#line 477 "scgrammer.y" /* yacc.c:1646  */
    { }
#line 2587 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 170:
#line 483 "scgrammer.y" /* yacc.c:1646  */
    { scparser_call(2,"coverpoint_begin",(yyvsp[0].string),(yyvsp[0].string)); SCFree((yyvsp[0].string)); }
#line 2593 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 171:
#line 484 "scgrammer.y" /* yacc.c:1646  */
    { scparser_call(-2,"coverpoint_begin",(yyvsp[-3].string),(yyvsp[-1].string)); }
#line 2599 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 172:
#line 487 "scgrammer.y" /* yacc.c:1646  */
    { scparser_call(1,"coverpoint","standard"); }
#line 2605 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 173:
#line 488 "scgrammer.y" /* yacc.c:1646  */
    { scparser_call(2,"coverpoint","standard_bins", (yyvsp[-2].string)); SCFree((yyvsp[-2].string)); }
#line 2611 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 174:
#line 489 "scgrammer.y" /* yacc.c:1646  */
    { scparser_call(2,"coverpoint","standard_bins", (yyvsp[-5].string)); SCFree((yyvsp[-5].string)); }
#line 2617 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 175:
#line 490 "scgrammer.y" /* yacc.c:1646  */
    { scparser_call(4,"coverpoint","standard_bins_range", (yyvsp[-8].string), (yyvsp[-4].string), (yyvsp[-2].string)); SCFree((yyvsp[-8].string)); }
#line 2623 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 176:
#line 491 "scgrammer.y" /* yacc.c:1646  */
    { scparser_call(4,"coverpoint","standard_bins_range", (yyvsp[-11].string), (yyvsp[-7].string), (yyvsp[-5].string)); SCFree((yyvsp[-11].string)); }
#line 2629 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 177:
#line 492 "scgrammer.y" /* yacc.c:1646  */
    { scparser_call(1,"coverpoint","bins"); }
#line 2635 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 178:
#line 498 "scgrammer.y" /* yacc.c:1646  */
    { scparser_call(2,"cross","item",(yyvsp[0].string)); SCFree((yyvsp[0].string)); }
#line 2641 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 179:
#line 501 "scgrammer.y" /* yacc.c:1646  */
    { }
#line 2647 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 180:
#line 502 "scgrammer.y" /* yacc.c:1646  */
    { }
#line 2653 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 181:
#line 505 "scgrammer.y" /* yacc.c:1646  */
    { scparser_call(1,"cross","start_rows"); }
#line 2659 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 182:
#line 506 "scgrammer.y" /* yacc.c:1646  */
    { scparser_call(1,"cross","start_cols"); }
#line 2665 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 183:
#line 507 "scgrammer.y" /* yacc.c:1646  */
    { scparser_call(1,"cross","start_table"); }
#line 2671 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 184:
#line 510 "scgrammer.y" /* yacc.c:1646  */
    {}
#line 2677 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 185:
#line 511 "scgrammer.y" /* yacc.c:1646  */
    { }
#line 2683 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 186:
#line 514 "scgrammer.y" /* yacc.c:1646  */
    { }
#line 2689 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 187:
#line 515 "scgrammer.y" /* yacc.c:1646  */
    { }
#line 2695 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 188:
#line 518 "scgrammer.y" /* yacc.c:1646  */
    { scparser_call(2,"cross_begin",(yyvsp[0].string),(yyvsp[0].string)); SCFree((yyvsp[0].string)); }
#line 2701 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 189:
#line 519 "scgrammer.y" /* yacc.c:1646  */
    { scparser_call(-2,"cross_begin",(yyvsp[-3].string),(yyvsp[-1].string)); }
#line 2707 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 190:
#line 525 "scgrammer.y" /* yacc.c:1646  */
    { scparser_call(-4,"coverpoint_window",(yyvsp[-7].string),(yyvsp[-5].string),(yyvsp[-3].string),(yyvsp[-1].string));}
#line 2713 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 191:
#line 528 "scgrammer.y" /* yacc.c:1646  */
    { }
#line 2719 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 192:
#line 529 "scgrammer.y" /* yacc.c:1646  */
    { }
#line 2725 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 193:
#line 535 "scgrammer.y" /* yacc.c:1646  */
    { scparser_call(0,"coverpoint_end"); }
#line 2731 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 194:
#line 536 "scgrammer.y" /* yacc.c:1646  */
    { scparser_call(0,"coverpoint_end"); }
#line 2737 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 195:
#line 537 "scgrammer.y" /* yacc.c:1646  */
    { scparser_call(0,"coverpoint_end"); }
#line 2743 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 196:
#line 539 "scgrammer.y" /* yacc.c:1646  */
    { }
#line 2749 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 197:
#line 542 "scgrammer.y" /* yacc.c:1646  */
    { }
#line 2755 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 198:
#line 543 "scgrammer.y" /* yacc.c:1646  */
    { }
#line 2761 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 199:
#line 546 "scgrammer.y" /* yacc.c:1646  */
    { scparser_call(0,"covergroup_end"); }
#line 2767 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 200:
#line 549 "scgrammer.y" /* yacc.c:1646  */
    { scparser_call(-1,"covergroup_begin",(yyvsp[0].string)); }
#line 2773 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 201:
#line 555 "scgrammer.y" /* yacc.c:1646  */
    { scparser_call(-1,"coversample",(yyvsp[-2].string)); }
#line 2779 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 202:
#line 562 "scgrammer.y" /* yacc.c:1646  */
    { scparser_call(4,"signal","sp_traced",(yyvsp[-3].string),(yyvsp[-2].string),(yyvsp[-1].string));
			  SCFree((yyvsp[-3].string)); SCFree((yyvsp[-2].string)); SCFree((yyvsp[-1].string));}
#line 2786 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 203:
#line 565 "scgrammer.y" /* yacc.c:1646  */
    { scparser_call(6,"signal","sp_traced_vl","uint32_t",(yyvsp[-7].string),(yyvsp[-6].string),(yyvsp[-4].string),(yyvsp[-2].string));
			  SCFree((yyvsp[-7].string)); SCFree((yyvsp[-6].string)); SCFree((yyvsp[-4].string)); SCFree((yyvsp[-2].string));}
#line 2793 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 204:
#line 568 "scgrammer.y" /* yacc.c:1646  */
    { scparser_call(6,"signal","sp_traced_vl","uint32_t",(yyvsp[-9].string),(yyvsp[-8].string),(yyvsp[-6].string),(yyvsp[-4].string));
			  SCFree((yyvsp[-9].string)); SCFree((yyvsp[-8].string)); SCFree((yyvsp[-6].string)); SCFree((yyvsp[-4].string)); SCFree((yyvsp[-2].string));}
#line 2800 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 205:
#line 571 "scgrammer.y" /* yacc.c:1646  */
    { scparser_call(6,"signal","vl_inout","uint32_t",(yyvsp[-7].string),(yyvsp[-6].string),(yyvsp[-4].string),(yyvsp[-2].string));
			  SCFree((yyvsp[-7].string)); SCFree((yyvsp[-6].string)); SCFree((yyvsp[-4].string)); SCFree((yyvsp[-2].string));}
#line 2807 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 206:
#line 574 "scgrammer.y" /* yacc.c:1646  */
    { scparser_call(6,"signal","vl_inout","uint32_t",(yyvsp[-9].string),(yyvsp[-8].string),(yyvsp[-6].string),(yyvsp[-4].string));
			  SCFree((yyvsp[-9].string)); SCFree((yyvsp[-8].string)); SCFree((yyvsp[-6].string)); SCFree((yyvsp[-4].string)); SCFree((yyvsp[-2].string));}
#line 2814 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 207:
#line 577 "scgrammer.y" /* yacc.c:1646  */
    { scparser_call(6,"signal","vl_in","uint32_t",(yyvsp[-7].string),(yyvsp[-6].string),(yyvsp[-4].string),(yyvsp[-2].string));
			  SCFree((yyvsp[-7].string)); SCFree((yyvsp[-6].string)); SCFree((yyvsp[-4].string)); SCFree((yyvsp[-2].string));}
#line 2821 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 208:
#line 580 "scgrammer.y" /* yacc.c:1646  */
    { scparser_call(6,"signal","vl_in","uint32_t",(yyvsp[-9].string),(yyvsp[-8].string),(yyvsp[-6].string),(yyvsp[-4].string));
			  SCFree((yyvsp[-9].string)); SCFree((yyvsp[-8].string)); SCFree((yyvsp[-6].string)); SCFree((yyvsp[-4].string)); SCFree((yyvsp[-2].string));}
#line 2828 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 209:
#line 583 "scgrammer.y" /* yacc.c:1646  */
    { scparser_call(6,"signal","vl_out","uint32_t",(yyvsp[-7].string),(yyvsp[-6].string),(yyvsp[-4].string),(yyvsp[-2].string));
			  SCFree((yyvsp[-7].string)); SCFree((yyvsp[-6].string)); SCFree((yyvsp[-4].string)); SCFree((yyvsp[-2].string));}
#line 2835 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 210:
#line 586 "scgrammer.y" /* yacc.c:1646  */
    { scparser_call(6,"signal","vl_out","uint32_t",(yyvsp[-9].string),(yyvsp[-8].string),(yyvsp[-6].string),(yyvsp[-4].string));
			  SCFree((yyvsp[-9].string)); SCFree((yyvsp[-8].string)); SCFree((yyvsp[-6].string)); SCFree((yyvsp[-4].string)); SCFree((yyvsp[-2].string));}
#line 2842 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 211:
#line 593 "scgrammer.y" /* yacc.c:1646  */
    { SCFree (scParserLex.enumname); }
#line 2848 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 212:
#line 594 "scgrammer.y" /* yacc.c:1646  */
    { SCFree (scParserLex.enumname); }
#line 2854 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 213:
#line 596 "scgrammer.y" /* yacc.c:1646  */
    { scParserLex.enumname = (yyvsp[0].string); }
#line 2860 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 214:
#line 597 "scgrammer.y" /* yacc.c:1646  */
    { scParserLex.enumname = NULL; }
#line 2866 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 215:
#line 599 "scgrammer.y" /* yacc.c:1646  */
    { }
#line 2872 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 216:
#line 600 "scgrammer.y" /* yacc.c:1646  */
    { }
#line 2878 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 217:
#line 602 "scgrammer.y" /* yacc.c:1646  */
    {
			if (scParserLex.enumname) scparser_call(3,"enum_value",scParserLex.enumname,(yyvsp[-1].string),(yyvsp[0].string));
			SCFree((yyvsp[-1].string)); SCFree((yyvsp[0].string)); }
#line 2886 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 218:
#line 606 "scgrammer.y" /* yacc.c:1646  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2892 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 219:
#line 607 "scgrammer.y" /* yacc.c:1646  */
    { (yyval.string) = strdup(""); }
#line 2898 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 220:
#line 609 "scgrammer.y" /* yacc.c:1646  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2904 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 221:
#line 610 "scgrammer.y" /* yacc.c:1646  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2910 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 222:
#line 611 "scgrammer.y" /* yacc.c:1646  */
    { (yyval.string) = scstrjoin2si((yyvsp[-2].string),"()"); }
#line 2916 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 223:
#line 612 "scgrammer.y" /* yacc.c:1646  */
    { (yyval.string) = scstrjoin4sisi((yyvsp[-3].string),"(",(yyvsp[-1].string),")"); }
#line 2922 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 224:
#line 614 "scgrammer.y" /* yacc.c:1646  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2928 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 225:
#line 615 "scgrammer.y" /* yacc.c:1646  */
    { (yyval.string) = scstrjoin3sis((yyvsp[-2].string),",",(yyvsp[0].string)); }
#line 2934 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 226:
#line 620 "scgrammer.y" /* yacc.c:1646  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2940 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 227:
#line 621 "scgrammer.y" /* yacc.c:1646  */
    { (yyval.string) = scstrjoin2ss((yyvsp[-1].string),(yyvsp[0].string)); }
#line 2946 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 228:
#line 624 "scgrammer.y" /* yacc.c:1646  */
    { (yyval.string) = strdup(""); }
#line 2952 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 229:
#line 625 "scgrammer.y" /* yacc.c:1646  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2958 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 230:
#line 628 "scgrammer.y" /* yacc.c:1646  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2964 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 231:
#line 629 "scgrammer.y" /* yacc.c:1646  */
    { (yyval.string) = scstrjoin2ss((yyvsp[-1].string),(yyvsp[0].string)); }
#line 2970 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 232:
#line 632 "scgrammer.y" /* yacc.c:1646  */
    { char *cp=malloc(strlen((yyvsp[-1].string))+5);
						  strcpy(cp,"["); strcat(cp,(yyvsp[-1].string)); strcat(cp,"]");
						  SCFree ((yyvsp[-1].string));
						  (yyval.string)=cp; }
#line 2979 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 233:
#line 638 "scgrammer.y" /* yacc.c:1646  */
    { (yyval.string) = strdup(""); }
#line 2985 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 234:
#line 639 "scgrammer.y" /* yacc.c:1646  */
    { (yyval.string) = (yyvsp[-1].string); }
#line 2991 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 235:
#line 642 "scgrammer.y" /* yacc.c:1646  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2997 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 236:
#line 643 "scgrammer.y" /* yacc.c:1646  */
    { (yyval.string) = (yyvsp[0].string); }
#line 3003 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 237:
#line 644 "scgrammer.y" /* yacc.c:1646  */
    { (yyval.string) = scstrjoin3sis ((yyvsp[-2].string),":",(yyvsp[0].string)); }
#line 3009 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 238:
#line 647 "scgrammer.y" /* yacc.c:1646  */
    { (yyval.string) = (yyvsp[0].string); }
#line 3015 "scgrammer.c" /* yacc.c:1646  */
    break;

  case 239:
#line 648 "scgrammer.y" /* yacc.c:1646  */
    { (yyval.string) = scstrjoin2is ("-",(yyvsp[0].string)); }
#line 3021 "scgrammer.c" /* yacc.c:1646  */
    break;


#line 3025 "scgrammer.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 651 "scgrammer.y" /* yacc.c:1906  */


const char *vlgrammer_tokename (int toke) {
    return (yytname[toke]);
}
